﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy3 Experiment Builder (v2020.2.0),
    on July 04, 2022, at 11:57
If you publish work using this script the most relevant publication is:

    Peirce J, Gray JR, Simpson S, MacAskill M, Höchenberger R, Sogo H, Kastman E, Lindeløv JK. (2019) 
        PsychoPy2: Experiments in behavior made easy Behav Res 51: 195. 
        https://doi.org/10.3758/s13428-018-01193-y

"""

from __future__ import absolute_import, division

from psychopy import locale_setup
from psychopy import prefs
from psychopy import sound, gui, visual, core, data, event, logging, clock
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)

import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle
import os  # handy system and path functions
import sys  # to get file system encoding

from psychopy.hardware import keyboard



# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__))
os.chdir(_thisDir)

# Store info about the experiment session
psychopyVersion = '2020.2.0'
expName = 'WM Task v1'  # from the Builder filename that created this script
expInfo = {'participant': '', 'session': '001'}
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName
expInfo['psychopyVersion'] = psychopyVersion

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath='D:\\OneDrive - University of Waterloo\\UW Research Associate\\Ethical Decision Making Online study\\PsychoPy\\WM Task v1_lastrun.py',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp
frameTolerance = 0.001  # how close to onset before 'same' frame

# Start Code - component code to be run before the window creation

# Setup the Window
win = visual.Window(
    size=[1536, 864], fullscr=True, screen=0, 
    winType='pyglet', allowGUI=False, allowStencil=False,
    monitor='testMonitor', color='white', colorSpace='rgb',
    blendMode='avg', useFBO=True, 
    units='height')
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess

# create a default keyboard (e.g. to check for escape)
defaultKeyboard = keyboard.Keyboard()

# Initialize components for Routine "WM_Instructions"
WM_InstructionsClock = core.Clock()
text = visual.TextStim(win=win, name='text',
    text='In this experiment you will be presented with a single letter and then a video.\n\nAfter responding to the video, you will then be presented with a single letter and you will have to decide whether this letter is the same as or different from the letter presented at the beginning of the trial.\n\nRespond with the keys:\n - "Z" if the letter was the SAME \n - "/" if the letter was DIFFERENT \n\nYou will perform a total of 16 trials.  Try to respond as quickly and as accurately as possible.\n\nWhen you are ready to proceed press the spacebar.',
    font='Arial',
    pos=(0, 0), height=0.04, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
ok = keyboard.Keyboard()
import random

Videos = ["Ethics_1sec_0-5_ped.mp4","Ethics_1sec_1-5_ped.mp4",
    "Ethics_1sec_5-0_ped.mp4","Ethics_1sec_5-1_ped.mp4",
    "Ethics_2sec_0-5_ped.mp4","Ethics_2sec_1-5_ped.mp4",
    "Ethics_2sec_5-0_ped.mp4","Ethics_2sec_5-1_ped.mp4",
    "Ethics_3sec_0-5_ped.mp4","Ethics_3sec_1-5_ped.mp4",
    "Ethics_3sec_5-0_ped.mp4","Ethics_3sec_5-1_ped.mp4",
    "NoPed_Catch1.mp4","NoPed_Catch2.mp4","NoPed_Catch3.mp4",
    "NoPed_Catch4.mp4"] 
random.shuffle(Videos)

pairlist = [("D","D","z"), ("T","T","z"), ("G","G","z"), ("I","I","z"), 
    ("E","E","z"), ("J","J","z"), ("F","F","z"), ("P","P","z"), 
    ("Y","K","slash"), ("B","T","slash"), ("U","N","slash"), ("Z","K","slash"),
    ("K","V","slash"), ("N","F","slash"), ("V","L","slash"), ("O","S","slash")]

random.shuffle(pairlist)
firststim = []
secondstim = []
corrAns = []

for i in pairlist:
    firststim.append(i[0])
    secondstim.append(i[1])
    corrAns.append(i[2])

# Initialize components for Routine "WM_1"
WM_1Clock = core.Clock()
presentSet = visual.TextStim(win=win, name='presentSet',
    text='default text',
    font='Arial',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
fixation1 = visual.ShapeStim(
    win=win, name='fixation1', vertices='cross',
    size=(0.02, 0.02),
    ori=0, pos=(0, 0),
    lineWidth=0.5, lineColor='black', lineColorSpace='rgb',
    fillColor='black', fillColorSpace='rgb',
    opacity=1, depth=-1.0, interpolate=True)

# Initialize components for Routine "trial"
trialClock = core.Clock()
key_resp = keyboard.Keyboard()

# Initialize components for Routine "WM_2"
WM_2Clock = core.Clock()
fixation2 = visual.ShapeStim(
    win=win, name='fixation2', vertices='cross',
    size=(0.02, 0.02),
    ori=0, pos=(0, 0),
    lineWidth=0.5, lineColor='black', lineColorSpace='rgb',
    fillColor='black', fillColorSpace='rgb',
    opacity=1, depth=0.0, interpolate=True)
presentProbe = visual.TextStim(win=win, name='presentProbe',
    text='default text',
    font='Arial',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-1.0);
key_resp_2 = keyboard.Keyboard()

# Initialize components for Routine "End"
EndClock = core.Clock()
text_2 = visual.TextStim(win=win, name='text_2',
    text='Experiment Over\n\nThank you for your participation!',
    font='Arial',
    pos=(0, 0), height=0.04, wrapWidth=None, ori=0, 
    color='black', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

# ------Prepare to start Routine "WM_Instructions"-------
continueRoutine = True
# update component parameters for each repeat
ok.keys = []
ok.rt = []
_ok_allKeys = []
# keep track of which components have finished
WM_InstructionsComponents = [text, ok]
for thisComponent in WM_InstructionsComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
WM_InstructionsClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "WM_Instructions"-------
while continueRoutine:
    # get current time
    t = WM_InstructionsClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=WM_InstructionsClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *text* updates
    if text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        text.frameNStart = frameN  # exact frame index
        text.tStart = t  # local t and not account for scr refresh
        text.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(text, 'tStartRefresh')  # time at next scr refresh
        text.setAutoDraw(True)
    
    # *ok* updates
    waitOnFlip = False
    if ok.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        ok.frameNStart = frameN  # exact frame index
        ok.tStart = t  # local t and not account for scr refresh
        ok.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(ok, 'tStartRefresh')  # time at next scr refresh
        ok.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(ok.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(ok.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if ok.status == STARTED and not waitOnFlip:
        theseKeys = ok.getKeys(keyList=['space'], waitRelease=False)
        _ok_allKeys.extend(theseKeys)
        if len(_ok_allKeys):
            ok.keys = _ok_allKeys[-1].name  # just the last key pressed
            ok.rt = _ok_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in WM_InstructionsComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "WM_Instructions"-------
for thisComponent in WM_InstructionsComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('text.started', text.tStartRefresh)
thisExp.addData('text.stopped', text.tStopRefresh)
# check responses
if ok.keys in ['', [], None]:  # No response was made
    ok.keys = None
thisExp.addData('ok.keys',ok.keys)
if ok.keys != None:  # we had a response
    thisExp.addData('ok.rt', ok.rt)
thisExp.addData('ok.started', ok.tStartRefresh)
thisExp.addData('ok.stopped', ok.tStopRefresh)
thisExp.nextEntry()
# the Routine "WM_Instructions" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
wm_trials = data.TrialHandler(nReps=16, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=[None],
    seed=None, name='wm_trials')
thisExp.addLoop(wm_trials)  # add the loop to the experiment
thisWm_trial = wm_trials.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisWm_trial.rgb)
if thisWm_trial != None:
    for paramName in thisWm_trial:
        exec('{} = thisWm_trial[paramName]'.format(paramName))

for thisWm_trial in wm_trials:
    currentLoop = wm_trials
    # abbreviate parameter names if possible (e.g. rgb = thisWm_trial.rgb)
    if thisWm_trial != None:
        for paramName in thisWm_trial:
            exec('{} = thisWm_trial[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "WM_1"-------
    continueRoutine = True
    routineTimer.add(3.500000)
    # update component parameters for each repeat
    presentSet.setText(firststim[wm_trials.thisN])
    # keep track of which components have finished
    WM_1Components = [presentSet, fixation1]
    for thisComponent in WM_1Components:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    WM_1Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "WM_1"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = WM_1Clock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=WM_1Clock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *presentSet* updates
        if presentSet.status == NOT_STARTED and tThisFlip >= 2-frameTolerance:
            # keep track of start time/frame for later
            presentSet.frameNStart = frameN  # exact frame index
            presentSet.tStart = t  # local t and not account for scr refresh
            presentSet.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(presentSet, 'tStartRefresh')  # time at next scr refresh
            presentSet.setAutoDraw(True)
        if presentSet.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > presentSet.tStartRefresh + 1.0-frameTolerance:
                # keep track of stop time/frame for later
                presentSet.tStop = t  # not accounting for scr refresh
                presentSet.frameNStop = frameN  # exact frame index
                win.timeOnFlip(presentSet, 'tStopRefresh')  # time at next scr refresh
                presentSet.setAutoDraw(False)
        
        # *fixation1* updates
        if fixation1.status == NOT_STARTED and tThisFlip >= 3.0-frameTolerance:
            # keep track of start time/frame for later
            fixation1.frameNStart = frameN  # exact frame index
            fixation1.tStart = t  # local t and not account for scr refresh
            fixation1.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(fixation1, 'tStartRefresh')  # time at next scr refresh
            fixation1.setAutoDraw(True)
        if fixation1.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > fixation1.tStartRefresh + 0.5-frameTolerance:
                # keep track of stop time/frame for later
                fixation1.tStop = t  # not accounting for scr refresh
                fixation1.frameNStop = frameN  # exact frame index
                win.timeOnFlip(fixation1, 'tStopRefresh')  # time at next scr refresh
                fixation1.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in WM_1Components:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "WM_1"-------
    for thisComponent in WM_1Components:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    wm_trials.addData('presentSet.started', presentSet.tStartRefresh)
    wm_trials.addData('presentSet.stopped', presentSet.tStopRefresh)
    wm_trials.addData('fixation1.started', fixation1.tStartRefresh)
    wm_trials.addData('fixation1.stopped', fixation1.tStopRefresh)
    
    # ------Prepare to start Routine "trial"-------
    continueRoutine = True
    # update component parameters for each repeat
    videos = visual.MovieStim3(
        win=win, name='videos',
        noAudio = False,
        filename=Videos[wm_trials.thisN],
        ori=0, pos=(0, 0), opacity=1,
        loop=False,
        depth=0.0,
        )
    key_resp.keys = []
    key_resp.rt = []
    _key_resp_allKeys = []
    # keep track of which components have finished
    trialComponents = [videos, key_resp]
    for thisComponent in trialComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    trialClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "trial"-------
    while continueRoutine:
        # get current time
        t = trialClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=trialClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *videos* updates
        if videos.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            videos.frameNStart = frameN  # exact frame index
            videos.tStart = t  # local t and not account for scr refresh
            videos.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(videos, 'tStartRefresh')  # time at next scr refresh
            videos.setAutoDraw(True)
        if videos.status == FINISHED:  # force-end the routine
            continueRoutine = False
        
        # *key_resp* updates
        waitOnFlip = False
        if key_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            key_resp.frameNStart = frameN  # exact frame index
            key_resp.tStart = t  # local t and not account for scr refresh
            key_resp.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(key_resp, 'tStartRefresh')  # time at next scr refresh
            key_resp.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(key_resp.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(key_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if key_resp.status == STARTED and not waitOnFlip:
            theseKeys = key_resp.getKeys(keyList=['space'], waitRelease=False)
            _key_resp_allKeys.extend(theseKeys)
            if len(_key_resp_allKeys):
                key_resp.keys = _key_resp_allKeys[-1].name  # just the last key pressed
                key_resp.rt = _key_resp_allKeys[-1].rt
                # a response ends the routine
                continueRoutine = False
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in trialComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "trial"-------
    for thisComponent in trialComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    videos.stop()
    # check responses
    if key_resp.keys in ['', [], None]:  # No response was made
        key_resp.keys = None
    wm_trials.addData('key_resp.keys',key_resp.keys)
    if key_resp.keys != None:  # we had a response
        wm_trials.addData('key_resp.rt', key_resp.rt)
    wm_trials.addData('key_resp.started', key_resp.tStartRefresh)
    wm_trials.addData('key_resp.stopped', key_resp.tStopRefresh)
    thisExp.addData('video file', Videos[wm_trials.thisN])
    # the Routine "trial" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # ------Prepare to start Routine "WM_2"-------
    continueRoutine = True
    # update component parameters for each repeat
    presentProbe.setText(secondstim[wm_trials.thisN])
    key_resp_2.keys = []
    key_resp_2.rt = []
    _key_resp_2_allKeys = []
    # keep track of which components have finished
    WM_2Components = [fixation2, presentProbe, key_resp_2]
    for thisComponent in WM_2Components:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    WM_2Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "WM_2"-------
    while continueRoutine:
        # get current time
        t = WM_2Clock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=WM_2Clock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *fixation2* updates
        if fixation2.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            fixation2.frameNStart = frameN  # exact frame index
            fixation2.tStart = t  # local t and not account for scr refresh
            fixation2.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(fixation2, 'tStartRefresh')  # time at next scr refresh
            fixation2.setAutoDraw(True)
        if fixation2.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > fixation2.tStartRefresh + 0.5-frameTolerance:
                # keep track of stop time/frame for later
                fixation2.tStop = t  # not accounting for scr refresh
                fixation2.frameNStop = frameN  # exact frame index
                win.timeOnFlip(fixation2, 'tStopRefresh')  # time at next scr refresh
                fixation2.setAutoDraw(False)
        
        # *presentProbe* updates
        if presentProbe.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
            # keep track of start time/frame for later
            presentProbe.frameNStart = frameN  # exact frame index
            presentProbe.tStart = t  # local t and not account for scr refresh
            presentProbe.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(presentProbe, 'tStartRefresh')  # time at next scr refresh
            presentProbe.setAutoDraw(True)
        
        # *key_resp_2* updates
        waitOnFlip = False
        if key_resp_2.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
            # keep track of start time/frame for later
            key_resp_2.frameNStart = frameN  # exact frame index
            key_resp_2.tStart = t  # local t and not account for scr refresh
            key_resp_2.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(key_resp_2, 'tStartRefresh')  # time at next scr refresh
            key_resp_2.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(key_resp_2.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(key_resp_2.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if key_resp_2.status == STARTED and not waitOnFlip:
            theseKeys = key_resp_2.getKeys(keyList=['z', 'slash'], waitRelease=False)
            _key_resp_2_allKeys.extend(theseKeys)
            if len(_key_resp_2_allKeys):
                key_resp_2.keys = _key_resp_2_allKeys[-1].name  # just the last key pressed
                key_resp_2.rt = _key_resp_2_allKeys[-1].rt
                # was this correct?
                if (key_resp_2.keys == str(corrAns[wm_trials.thisN])) or (key_resp_2.keys == corrAns[wm_trials.thisN]):
                    key_resp_2.corr = 1
                else:
                    key_resp_2.corr = 0
                # a response ends the routine
                continueRoutine = False
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in WM_2Components:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "WM_2"-------
    for thisComponent in WM_2Components:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    wm_trials.addData('fixation2.started', fixation2.tStartRefresh)
    wm_trials.addData('fixation2.stopped', fixation2.tStopRefresh)
    wm_trials.addData('presentProbe.started', presentProbe.tStartRefresh)
    wm_trials.addData('presentProbe.stopped', presentProbe.tStopRefresh)
    # check responses
    if key_resp_2.keys in ['', [], None]:  # No response was made
        key_resp_2.keys = None
        # was no response the correct answer?!
        if str(corrAns[wm_trials.thisN]).lower() == 'none':
           key_resp_2.corr = 1;  # correct non-response
        else:
           key_resp_2.corr = 0;  # failed to respond (incorrectly)
    # store data for wm_trials (TrialHandler)
    wm_trials.addData('key_resp_2.keys',key_resp_2.keys)
    wm_trials.addData('key_resp_2.corr', key_resp_2.corr)
    if key_resp_2.keys != None:  # we had a response
        wm_trials.addData('key_resp_2.rt', key_resp_2.rt)
    wm_trials.addData('key_resp_2.started', key_resp_2.tStartRefresh)
    wm_trials.addData('key_resp_2.stopped', key_resp_2.tStopRefresh)
    thisExp.addData('first stim', firststim[wm_trials.thisN])
    thisExp.addData('second stim', secondstim[wm_trials.thisN])
    # the Routine "WM_2" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    thisExp.nextEntry()
    
# completed 16 repeats of 'wm_trials'


# ------Prepare to start Routine "End"-------
continueRoutine = True
routineTimer.add(3.000000)
# update component parameters for each repeat
# keep track of which components have finished
EndComponents = [text_2]
for thisComponent in EndComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
EndClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "End"-------
while continueRoutine and routineTimer.getTime() > 0:
    # get current time
    t = EndClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=EndClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *text_2* updates
    if text_2.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        text_2.frameNStart = frameN  # exact frame index
        text_2.tStart = t  # local t and not account for scr refresh
        text_2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(text_2, 'tStartRefresh')  # time at next scr refresh
        text_2.setAutoDraw(True)
    if text_2.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > text_2.tStartRefresh + 3-frameTolerance:
            # keep track of stop time/frame for later
            text_2.tStop = t  # not accounting for scr refresh
            text_2.frameNStop = frameN  # exact frame index
            win.timeOnFlip(text_2, 'tStopRefresh')  # time at next scr refresh
            text_2.setAutoDraw(False)
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in EndComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "End"-------
for thisComponent in EndComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('text_2.started', text_2.tStartRefresh)
thisExp.addData('text_2.stopped', text_2.tStopRefresh)

# Flip one final time so any remaining win.callOnFlip() 
# and win.timeOnFlip() tasks get executed before quitting
win.flip()

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv', delim='auto')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
